#include "Arduino.h"
#include "config.h"
#include "def.h"
#include "types.h"
#include "Serial.h"
#include "Protocol.h"
#include "MultiWii.h"
#include "Alarms.h"
#include "Si4432.h"

/**************************************************************************************/
/***************             Global RX related variables           ********************/
/**************************************************************************************/


RF22 rf22(0);
volatile uint16_t rcValue[RC_CHANS] = {1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502}; // interval [1000;2000]

byte msgData[RF22_MAX_MESSAGE_LEN];
uint8_t msgLen ;
uint32_t sendTime;

void computeRC()
{
	if (sendTime>micros())
	{	
		return;
	}
	sendTime=0;

	if ((rf22.mode()&2))
		rf22.setModeRx();


	if ( rf22.available())
	{	
		msgLen = RF22_MAX_MESSAGE_LEN;
		if (rf22.recv(msgData, &msgLen) && msgLen ==16)
		{
			rcData[THROTTLE] =1000+ msgData[1] +  msgData[2] * 256;
			rcData[PITCH] = 1000+ msgData[3]+msgData[4]		 *256;
			rcData[ROLL] = 1000+ msgData[5]+msgData[6]		 *256;			
			rcData[YAW] =  1000+ msgData[7]+msgData[8]		 *256;			
			rcData[AUX1] = ((msgData[9] & 0b01000000)==0b01000000) ? 2000: 1500;
			rcData[AUX2] = ((msgData[9] & 0b00010000)==0b00010000) ? 2000: ((msgData[9] & 0b10000000)==0b10000000)? 1000:1500;
			rcData[AUX3] = ((msgData[9] & 0b00001000)==0b00001000) ? 2000: ((msgData[9] & 0b00100000)==0b00100000)? 1000:1500;
			rcData[AUX4] = ((msgData[9] & 0b00000100)==0b00000100) ? 2000: ((msgData[9] & 0b00000010)==0b00000010)? 1000:1500;
			analog.rssi = rf22.rssiRead();		
			if (msgData[0]&(1<<6) )
			{	
				msgData[0]= (f.OK_TO_ARM) | (f.ARMED <<1) | (f.ANGLE_MODE<<2) | (f.HORIZON_MODE<<3)| (f.BARO_MODE<<4)|(f.MAG_MODE<<5)|(f.HEADFREE_MODE<<6)|(f.PASSTHRU_MODE<<7);
				msgData[1]= analog.vbat;
				msgData[2]= analog.rssi;				
				rf22.send(msgData,16);		
				sendTime = micros()+10000;
			}				
		}
	}
}

void irq()
{
	rf22.check();	
}
void configureReceiver() 
{
	pinMode(2, INPUT);
	if (!rf22.init())
	{
		rf22.reset();
		digitalWrite(12,1);
		delay(500);
		digitalWrite(12,0);
		delay(500);
	}
	
	//rf22.setTxPower(RF22_TXPOW_20DBM);
	attachInterrupt(0, irq, FALLING); 
	rf22.setFrequency(442);
	rf22.setModeRx();
}






